using System;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace VCCCompiler
{
        /// <summary>
        /// Zusammenfassung fr MyCompiler.
        /// </summary>
        class MyCompiler
        {
                YYARec[] yya;
                YYARec[] yyg;
                YYRRec[] yyr;
                int[] yyd;
                int[] yyal;
                int[] yyah;
                int[] yygl;
                int[] yygh;

                int yyn = 0;
                int yystate = 0;
                int yychar = -1;
                int yynerrs = 0;
                int yyerrflag = 0;
                int yysp = 0;
                int yymaxdepth = 1024;
                int yyflag = 0;
                int yyfnone   = 0;
                int[] yys = new int[1024];
                string[] yyv = new string[1024];

                string yyval = "";

                FileStream OutputStream;
                StreamWriter Output;

                class YYARec
                {
                        public int sym;
                        public int act;
                        public YYARec (int s, int a){ sym = s; act = a; }
                }

                class YYRRec
                {
                        public int len;
                        public int sym;
                        public YYRRec (int l, int s){ sym = s; len = l; }
                }

                ////////////////////////////////////////////////////////////////
                /// Constant values / tokens
                ////////////////////////////////////////////////////////////////
                int t_Unterstrich = 257;
                int t_T_8 = 258;
                int t_T_16 = 259;
                int t_T_32 = 260;
                int t_T_1 = 261;
                int t_T_2 = 262;
                int t_T_4 = 263;
                int t_T_0 = 264;
                int t_G = 265;
                int t_A = 266;
                int t_H = 267;
                int t_F = 268;
                int t_C = 269;
                int t_D = 270;
                int t_E = 271;
                int t_ignore = 256;
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////
int x = 10;

///////////////////////////////////////////////////////////


                /// <summary>
                /// Der Haupteinstiegspunkt fr die Anwendung.
                /// </summary>
                [STAThread]
                static int Main(string[] args)
                {

                        bool ShowTokens = false;
                        string InputFilename = "";
                        string OutputFilename = "";

                        foreach (string s in args)
                        {
                                if (s.ToLower() == "-t")
                                {
                                        ShowTokens = true;
                                }
                                else
                                {
                                        if (InputFilename == "")  InputFilename = s; else
                                        if (OutputFilename == "") OutputFilename = s; else
                                        {
                                                Console.WriteLine("Too many arguments!");
                                                return 1;
                                        }
                                }
                        }
                        if (InputFilename == "")
                        {
                                System.Console.WriteLine("You need to specify input and outputfile: compiler.exe input.txt output.txt");
                                return 1;
                        }

                        StreamReader in_s = File.OpenText(InputFilename);
                        string inputstream = in_s.ReadToEnd();
                        in_s.Close();

                        ////////////////////////////////////////////////////////////////
                        /// Compiler Code:
                        ////////////////////////////////////////////////////////////////
                        MyCompiler compiler = new MyCompiler();
                        compiler.Output = null;
                        if (OutputFilename != "")
                        {
                                File.Delete(OutputFilename);
                                compiler.OutputStream = File.OpenWrite(OutputFilename);
                                compiler.Output = new StreamWriter(compiler.OutputStream);
                        }
                        else
                        {
                                compiler.Output = new StreamWriter(Console.OpenStandardOutput());

                        }

                        if (!compiler.Scanner(inputstream)) return 1;
                        if (ShowTokens)
                        {
                                foreach (AToken t in compiler.TokenList)
                                {
                                        Console.WriteLine("TokenID: "+t.token+"  =  "+t.val);
                                }
                        }
                        compiler.InitTables();
                        if (!compiler.yyparse()) return 1;

                        if (compiler.Output != null) compiler.Output.Close();
			return 0;
                }
                public void yyaction (int yyruleno)
                {
                        switch (yyruleno)
                        {
                                ////////////////////////////////////////////////////////////////
                                /// YYAction code:
                                ////////////////////////////////////////////////////////////////
							case    1 : 
         yyval = "<?xml version=\"1.0\" ?>\r\n";
         yyval += "<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20010904//EN\" \"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\r\n";
         yyval += "<svg width=\"1200\" height=\"100\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\">\r\n";
         yyval += " <rect x=\"0\" y=\"0\" width=\"1200\" height=\"100\" fill=\"lightyellow\" />\r\n";
         yyval += "   <line x1=\"0\" y1=\"30\" x2=\"1200\" y2=\"30\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += "   <line x1=\"0\" y1=\"40\" x2=\"1200\" y2=\"40\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += "   <line x1=\"0\" y1=\"50\" x2=\"1200\" y2=\"50\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += "   <line x1=\"0\" y1=\"60\" x2=\"1200\" y2=\"60\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += "   <line x1=\"0\" y1=\"70\" x2=\"1200\" y2=\"70\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         
         yyval += yyv[yysp-0]+"\r\n";  
         
         yyval += "</svg>";
         
         Output.WriteLine(yyval);
         
       break;
							case    2 : 
         yyval = yyv[yysp-1]+yyv[yysp-0];
         
       break;
							case    3 : 
         
       break;
							case    4 : 
         int cy = 0;
         
         if (yyv[yysp-2] == "C0") cy = 80;  if (yyv[yysp-2] == "C1") cy = 45;
         if (yyv[yysp-2] == "D0") cy = 75;  if (yyv[yysp-2] == "D1") cy = 40;
         if (yyv[yysp-2] == "E0") cy = 70;  if (yyv[yysp-2] == "E1") cy = 35;
         if (yyv[yysp-2] == "F0") cy = 65;  if (yyv[yysp-2] == "F1") cy = 30;
         if (yyv[yysp-2] == "G0") cy = 60;  if (yyv[yysp-2] == "G1") cy = 25;
         if (yyv[yysp-2] == "A0") cy = 55;  if (yyv[yysp-2] == "A1") cy = 20;
         if (yyv[yysp-2] == "H0") cy = 50;  if (yyv[yysp-2] == "H1") cy = 15;
         
         yyval = "<ellipse cx=\"" +x+ "\" cy=\""+cy+"\" rx=\"8\" ry=\"5\" style=\"fill:black;\"/>";
         
         if (yyv[yysp-0] == "2" || yyv[yysp-0] == "4" || yyv[yysp-0] == "8")  
         yyval = yyval + "<line x1=\""+(x+8)+"\" y1=\"" + cy +"\" x2=\""+(x+8)+"\" y2=\""+ (cy-30)+"\" style=\"stroke:black;stroke-width:2\" />"; 
         
         if (yyv[yysp-0] == "1" || yyv[yysp-0] == "2")   
         yyval = yyval + "<ellipse cx=\"" +x+ "\" cy=\""+cy+"\" rx=\"3\" ry=\"4\" style=\"fill:white;\"/>"; 
         
         if (yyv[yysp-0] == "8")  
         yyval = yyval + "<path d=\"M "+(x+8)+"," + (cy-30) +" q 0,10 5,10 t 5,10\" style=\"stroke:black;\" />"; 
         
         x += 40;
         
       break;
							case    5 : 
         
       break;
							case    6 : 
         
       break;
							case    7 : 
         
       break;
							case    8 : 
         
       break;
							case    9 : 
         
       break;
							case   10 : 
         
       break;
							case   11 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case   12 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case   13 : 
         
       break;
							case   14 : 
         
       break;
							case   15 : 
         
       break;
							case   16 : 
         
       break;
							case   17 : 
         
       break;
							case   18 : 
         
       break;
							case   19 : 
         
       break;
                                default : return;
                        }
                }

                public void InitTables()
                {
                        ////////////////////////////////////////////////////////////////
                        /// Init Table code:
                        ////////////////////////////////////////////////////////////////

					int yynacts   = 25;
					int yyngotos  = 10;
					int yynstates = 24;
					int yynrules  = 19;
					yya = new YYARec[yynacts+1];  int yyac = 1;
					yyg = new YYARec[yyngotos+1]; int yygc = 1;
					yyr = new YYRRec[yynrules+1]; int yyrc = 1;

					yya[yyac] = new YYARec(265,6);yyac++; 
					yya[yyac] = new YYARec(266,7);yyac++; 
					yya[yyac] = new YYARec(267,8);yyac++; 
					yya[yyac] = new YYARec(268,9);yyac++; 
					yya[yyac] = new YYARec(269,10);yyac++; 
					yya[yyac] = new YYARec(270,11);yyac++; 
					yya[yyac] = new YYARec(271,12);yyac++; 
					yya[yyac] = new YYARec(261,13);yyac++; 
					yya[yyac] = new YYARec(264,14);yyac++; 
					yya[yyac] = new YYARec(257,15);yyac++; 
					yya[yyac] = new YYARec(265,6);yyac++; 
					yya[yyac] = new YYARec(266,7);yyac++; 
					yya[yyac] = new YYARec(267,8);yyac++; 
					yya[yyac] = new YYARec(268,9);yyac++; 
					yya[yyac] = new YYARec(269,10);yyac++; 
					yya[yyac] = new YYARec(270,11);yyac++; 
					yya[yyac] = new YYARec(271,12);yyac++; 
					yya[yyac] = new YYARec(0,-3 );yyac++; 
					yya[yyac] = new YYARec(0,0);yyac++; 
					yya[yyac] = new YYARec(258,18);yyac++; 
					yya[yyac] = new YYARec(259,19);yyac++; 
					yya[yyac] = new YYARec(260,20);yyac++; 
					yya[yyac] = new YYARec(261,21);yyac++; 
					yya[yyac] = new YYARec(262,22);yyac++; 
					yya[yyac] = new YYARec(263,23);yyac++;

					yyg[yygc] = new YYARec(-7,1);yygc++; 
					yyg[yygc] = new YYARec(-5,2);yygc++; 
					yyg[yygc] = new YYARec(-4,3);yygc++; 
					yyg[yygc] = new YYARec(-3,4);yygc++; 
					yyg[yygc] = new YYARec(-2,5);yygc++; 
					yyg[yygc] = new YYARec(-7,1);yygc++; 
					yyg[yygc] = new YYARec(-5,2);yygc++; 
					yyg[yygc] = new YYARec(-4,3);yygc++; 
					yyg[yygc] = new YYARec(-3,16);yygc++; 
					yyg[yygc] = new YYARec(-6,17);yygc++;

					yyd = new int[yynstates];
					yyd[0] = 0;  
					yyd[1] = 0;  
					yyd[2] = 0;  
					yyd[3] = 0;  
					yyd[4] = -1;  
					yyd[5] = 0;  
					yyd[6] = -13;  
					yyd[7] = -14;  
					yyd[8] = -15;  
					yyd[9] = -16;  
					yyd[10] = -17;  
					yyd[11] = -18;  
					yyd[12] = -19;  
					yyd[13] = -11;  
					yyd[14] = -12;  
					yyd[15] = 0;  
					yyd[16] = -2;  
					yyd[17] = -4;  
					yyd[18] = -5;  
					yyd[19] = -6;  
					yyd[20] = -7;  
					yyd[21] = -8;  
					yyd[22] = -9;  
					yyd[23] = -10; 

					yyal = new int[yynstates];
					yyal[0] = 1;  
					yyal[1] = 8;  
					yyal[2] = 10;  
					yyal[3] = 11;  
					yyal[4] = 19;  
					yyal[5] = 19;  
					yyal[6] = 20;  
					yyal[7] = 20;  
					yyal[8] = 20;  
					yyal[9] = 20;  
					yyal[10] = 20;  
					yyal[11] = 20;  
					yyal[12] = 20;  
					yyal[13] = 20;  
					yyal[14] = 20;  
					yyal[15] = 20;  
					yyal[16] = 26;  
					yyal[17] = 26;  
					yyal[18] = 26;  
					yyal[19] = 26;  
					yyal[20] = 26;  
					yyal[21] = 26;  
					yyal[22] = 26;  
					yyal[23] = 26; 

					yyah = new int[yynstates];
					yyah[0] = 7;  
					yyah[1] = 9;  
					yyah[2] = 10;  
					yyah[3] = 18;  
					yyah[4] = 18;  
					yyah[5] = 19;  
					yyah[6] = 19;  
					yyah[7] = 19;  
					yyah[8] = 19;  
					yyah[9] = 19;  
					yyah[10] = 19;  
					yyah[11] = 19;  
					yyah[12] = 19;  
					yyah[13] = 19;  
					yyah[14] = 19;  
					yyah[15] = 25;  
					yyah[16] = 25;  
					yyah[17] = 25;  
					yyah[18] = 25;  
					yyah[19] = 25;  
					yyah[20] = 25;  
					yyah[21] = 25;  
					yyah[22] = 25;  
					yyah[23] = 25; 

					yygl = new int[yynstates];
					yygl[0] = 1;  
					yygl[1] = 6;  
					yygl[2] = 6;  
					yygl[3] = 6;  
					yygl[4] = 10;  
					yygl[5] = 10;  
					yygl[6] = 10;  
					yygl[7] = 10;  
					yygl[8] = 10;  
					yygl[9] = 10;  
					yygl[10] = 10;  
					yygl[11] = 10;  
					yygl[12] = 10;  
					yygl[13] = 10;  
					yygl[14] = 10;  
					yygl[15] = 10;  
					yygl[16] = 11;  
					yygl[17] = 11;  
					yygl[18] = 11;  
					yygl[19] = 11;  
					yygl[20] = 11;  
					yygl[21] = 11;  
					yygl[22] = 11;  
					yygl[23] = 11; 

					yygh = new int[yynstates];
					yygh[0] = 5;  
					yygh[1] = 5;  
					yygh[2] = 5;  
					yygh[3] = 9;  
					yygh[4] = 9;  
					yygh[5] = 9;  
					yygh[6] = 9;  
					yygh[7] = 9;  
					yygh[8] = 9;  
					yygh[9] = 9;  
					yygh[10] = 9;  
					yygh[11] = 9;  
					yygh[12] = 9;  
					yygh[13] = 9;  
					yygh[14] = 9;  
					yygh[15] = 10;  
					yygh[16] = 10;  
					yygh[17] = 10;  
					yygh[18] = 10;  
					yygh[19] = 10;  
					yygh[20] = 10;  
					yygh[21] = 10;  
					yygh[22] = 10;  
					yygh[23] = 10; 

					yyr[yyrc] = new YYRRec(1,-2);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-5);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-5);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++;
                }

                public bool yyact(int state, int sym , ref int act)
                {
                        int k = yyal[state];
                        while ( k <= yyah[state] && yya[k].sym != sym) k++;
                        if (k > yyah[state]) return false;
                        act = yya[k].act;
                        return true;
                }
                public bool yygoto(int state, int sym , ref int nstate)
                {
                        int k = yygl[state];
                        while ( k <= yygh[state] && yyg[k].sym != sym) k++;
                        if (k > yygh[state]) return false;
                        nstate = yyg[k].act;
                        return true;
                }

                public void yyerror (string s)
                {
                        System.Console.Write(s);
                }

                int yylexpos = -1;
                string yylval = "";

                public int yylex ()
                {
                        yylexpos++;
                        if(yylexpos >= TokenList.Count)
                        {
                                yylval = "";
                                return 0;
                        }
                        else
                        {
                                yylval = ((AToken)TokenList[yylexpos]).val;
                                return ((AToken)TokenList[yylexpos]).token;
                        }
                }

                public bool yyparse ()
                {

                        parse:

                                yysp++;
                        if (yysp>yymaxdepth)
                        {
                                yyerror("yyparse stack overflow");
                                goto abort;
                        }

                        yys[yysp] = yystate;
                        yyv[yysp] = yyval;

                        next:

                                if (yyd[yystate]==0 && yychar==-1)
                                {
                                        yychar = yylex();
                                        if (yychar<0) yychar = 0;
                                }

                        yyn = yyd[yystate];
                        if (yyn != 0) goto reduce;


                        if (! yyact(yystate, yychar, ref yyn)) goto error;
                        else if (yyn>0) goto shift;
                        else if (yyn<0) goto reduce;
                        else            goto accept;

                        error:

                                if (yyerrflag==0) yyerror("syntax error");

                        errlab:

                                if (yyerrflag==0) yynerrs++;

                        if (yyerrflag<=2)
                        {
                                yyerrflag = 3;
                                while (yysp>0 && !(yyact(yys[yysp], 255, ref yyn) && yyn > 0)) yysp--;

                                if (yysp==0) goto abort;
                                yystate = yyn;
                                goto parse;
                        }
                        else
                        {
                                if (yychar==0) goto abort;
                                yychar = -1; goto next;
                        }

                        shift:

                        yystate = yyn;
                        yychar = -1;
                        yyval = yylval;
                        if (yyerrflag>0) yyerrflag--;
                        goto parse;

                        reduce:

                        yyflag = yyfnone;
                        yyaction(-yyn);
                        yysp -= yyr[-yyn].len;

                        if (yygoto(yys[yysp], yyr[-yyn].sym, ref yyn)) yystate = yyn;

                        switch (yyflag)
                        {
                                case 1 : goto accept;
                                case 2 : goto abort;
                                case 3 : goto errlab;
                        }

                        goto parse;

                        accept:

                                return true;

                        abort:

                                return false;
                }
		////////////////////////////////////////////////////////////////
		/// Scanner
		////////////////////////////////////////////////////////////////

		public class AToken
		{
			public int token;
			public string val;
		}

		ArrayList TokenList = new ArrayList();

		public bool Scanner (string Input)
		{
		        if (Input.Length == 0) return true;
			TokenList = new ArrayList();
			while (1==1)
			{
				AToken lasttoken = FindToken(Input);
				if (lasttoken.token == 0) break;
				if (lasttoken.token != t_ignore) TokenList.Add(lasttoken);
				if (Input.Length > lasttoken.val.Length)
				Input = Input.Substring(lasttoken.val.Length); else return true;
			}
                      System.Console.WriteLine(Input);
			System.Console.WriteLine();
			System.Console.WriteLine("No matching token found!");
			return false;
		}
		public AToken FindToken (string Rest)
		{
			ArrayList Results  = new ArrayList();
			ArrayList ResultsV = new ArrayList();
                      try{

			if (Regex.IsMatch(Rest,"^(_)",RegexOptions.IgnoreCase)){
				Results.Add (t_Unterstrich);
				ResultsV.Add(Regex.Match(Rest,"^(_)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(8)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_8);
				ResultsV.Add(Regex.Match(Rest,"^(8)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(16)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_16);
				ResultsV.Add(Regex.Match(Rest,"^(16)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(32)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_32);
				ResultsV.Add(Regex.Match(Rest,"^(32)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(1)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_1);
				ResultsV.Add(Regex.Match(Rest,"^(1)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(2)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_2);
				ResultsV.Add(Regex.Match(Rest,"^(2)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(4)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_4);
				ResultsV.Add(Regex.Match(Rest,"^(4)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(0)",RegexOptions.IgnoreCase)){
				Results.Add (t_T_0);
				ResultsV.Add(Regex.Match(Rest,"^(0)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(G)",RegexOptions.IgnoreCase)){
				Results.Add (t_G);
				ResultsV.Add(Regex.Match(Rest,"^(G)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(A)",RegexOptions.IgnoreCase)){
				Results.Add (t_A);
				ResultsV.Add(Regex.Match(Rest,"^(A)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(H)",RegexOptions.IgnoreCase)){
				Results.Add (t_H);
				ResultsV.Add(Regex.Match(Rest,"^(H)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(F)",RegexOptions.IgnoreCase)){
				Results.Add (t_F);
				ResultsV.Add(Regex.Match(Rest,"^(F)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(C)",RegexOptions.IgnoreCase)){
				Results.Add (t_C);
				ResultsV.Add(Regex.Match(Rest,"^(C)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(D)",RegexOptions.IgnoreCase)){
				Results.Add (t_D);
				ResultsV.Add(Regex.Match(Rest,"^(D)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^(E)",RegexOptions.IgnoreCase)){
				Results.Add (t_E);
				ResultsV.Add(Regex.Match(Rest,"^(E)",RegexOptions.IgnoreCase).Value);}

			if (Regex.IsMatch(Rest,"^([\\r\\n\\t\\s])",RegexOptions.IgnoreCase)){
				Results.Add (t_ignore);
				ResultsV.Add(Regex.Match(Rest,"^([\\r\\n\\t\\s])",RegexOptions.IgnoreCase).Value);}

			}catch{}
			int maxlength = 0;
			int besttoken = 0;
			AToken ret = new AToken();
		        ret.token = besttoken;
			for (int i = 0; i < Results.Count; i++){
				if (ResultsV[i].ToString().Length > maxlength)
				{
					maxlength = ResultsV[i].ToString().Length;
					besttoken = (int)Results[i];
		         	        ret.token = besttoken;
		                  	if (besttoken != 0)
			                ret.val   = ResultsV[i].ToString();
				}
			}
			return ret;
		}

	}
}
